package com.localmatters;

import com.localmatters.mobile.horoscope.HoroscopeDescription;
import com.localmatters.mobile.horoscope.HoroscopeRemote;
import java.io.*;
import java.util.Hashtable;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author Daniel Cavalcanti
 */
public class HoroscopeServlet extends HttpServlet {
    
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        
        try {
            
            Hashtable params = new Hashtable();
            params.put("java.naming.factory.initial",  "com.sun.enterprise.naming.SerialInitContextFactory");
            params.put("java.naming.factory.url.pkgs", "com.sun.enterprise.naming");
            params.put("java.naming.factory.state",    "com.sun.corba.ee.impl.presentation.rmi.JNDIStateFactoryImpl");
            params.put("org.omg.CORBA.ORBInitialHost", "localhost");
            params.put("org.omg.CORBA.ORBInitialPort", "3700");
            
            InitialContext ic = new InitialContext(params);
            HoroscopeRemote bean = (HoroscopeRemote) ic.lookup(HoroscopeRemote.class.getName());
            HoroscopeDescription description = bean.horoscope();
            
            response.setContentType("text/html;charset=UTF-8");
            PrintWriter out = response.getWriter();
            out.println("<html>");
            out.println("<head><title>HoroscopeServlet</title></head>");
            out.println("<body>" + description + "</body>");
            out.println("</html>");
            out.close();
            
        } catch (Exception ex) {
            throw new ServletException("Error: " + ex.getMessage(), ex);
        }
        
    }
    
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
}
